addHook("PreThinkFrame", function(player)
	for player in players.iterate()
		-- Validity check
		if not (
			A_CheckExistence(player)
			and player.mo.skin == "tails"
			and player.playerstate == PST_LIVE
		)
			continue
		end
		
		local mo = player.mo
		
		-- Have to have flight or swimming to stay in tired flying state
		if not (mo.eflags&MFE_UNDERWATER)
			-- Swimming doesn't affect air flight physics, so go with that
			player.charability = CA_SWIM
		else
			-- Having swimming does affect swimming physics, so take it away underwater
			player.charability = CA_NONE
			-- Also infinite vertboost count when swimming
			A_ResetFlightCount(player)
		end
		
		-- Eat all remaining flys if you've aircurled
		if mo.flytimer > 0 and mo.aircurled
			mo.flycount = 0
			return
		end
		
		-- Apply PF_THOKKED if you have no flys left, otherwise don't
		if mo.flycount <= 0
			player.pflags = $ | PF_THOKKED
		else
			player.pflags = $ & ~PF_THOKKED
		end
	end
end)

addHook("ThinkFrame", function(player)
	for player in players.iterate()
		-- Validity check
		if not (
			A_CheckExistence(player)
			and player.mo.skin == "tails"
			and player.playerstate == PST_LIVE
		)
			continue
		end
		
		local mo = player.mo
		
		-- Don't do flying physics if you're not flying
		if not (
			mo.state == S_PLAY_FLY 
			or mo.state == S_PLAY_FLY_TIRED
			or mo.state == S_PLAY_SWIM
		)
			continue
		end
		
		-- Do flying physics
		A_TailsHover(player)
	end
end)

addHook("AbilitySpecial", A_TailsFly)